using System.Collections.ObjectModel;

using Microsoft.UI.Xaml.Controls;

using CommunityToolkit.WinUI;

namespace TestProject;

/// <summary>
///  
/// </summary>
public sealed partial class MainPage : Page
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Property
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region ׸ ÷ - ItemCollection

    /// <summary>
    /// ׸ ÷
    /// </summary>
    public ObservableCollection<string> ItemCollection { get; set; } = [];

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
    ////////////////////////////////////////////////////////////////////////////////////////// Public

    #region  - MainPage()

    /// <summary>
    /// 
    /// </summary>
    public MainPage()
    {
        InitializeComponent();

        this.listView.SelectionChanged += listView_SelectionChanged;

        ItemCollection = GetItemCollection(200);
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Private
    //////////////////////////////////////////////////////////////////////////////// Event

    #region Ʈ    óϱ - listView_SelectionChanged(sender, e)

    /// <summary>
    /// Ʈ    óϱ
    /// </summary>
    /// <param name="sender">̺Ʈ ߻</param>
    /// <param name="e">̺Ʈ </param>
    private async void listView_SelectionChanged(object sender, SelectionChangedEventArgs e)
    {
        if(sender is ListView listView)
        {
            await listView.SmoothScrollIntoViewWithIndexAsync(listView.SelectedIndex, ScrollItemPlacement.Center, false, true);
        }
    }

    #endregion

    //////////////////////////////////////////////////////////////////////////////// Function

    #region ׸ ÷ ϱ - GetItemCollection(itemCount)

    /// <summary>
    /// ׸ ÷ ϱ
    /// </summary>
    /// <param name="itemCount">׸ </param>
    /// <returns>׸ ÷</returns>
    private ObservableCollection<string> GetItemCollection(int itemCount)
    {
        ObservableCollection<string> collection = [];

        for(int i = 0; i < itemCount; i++)
        {
            string item = (i % 2) == 0 ? $"{i} - Even" : $"{i} - Odd";

            collection.Add(item);
        }

        return collection;
    }

    #endregion
}